[PATCHv4 2/2] filter-branch: Add tests for submodules in tree-filter

Previous message: [thread] [date] [author]
Next message: [thread] [date] [author]
From: Michal Sojka
Date: Thursday, January 28, 2010 - 2:08 am

Add tests to make sure:
1) a submodule can be removed and its content replaced with regular
   files ('rewrite submodule with another content'). This test passes
   only with the previous patch applied.

2) it is possible to replace submodule revision by direct index
   manipulation ('replace submodule revision'). Although it would be
   better to run such a filter in --index-filter, this test shows that
   this functionality is not broken by the previous patch. This
   succeeds both with and without the previous patch.

Signed-off-by: Michal Sojka <sojkam1@fel.cvut.cz>
---
 t/t7003-filter-branch.sh |   39 +++++++++++++++++++++++++++++++++++++++
 1 files changed, 39 insertions(+), 0 deletions(-)

diff --git a/t/t7003-filter-branch.sh b/t/t7003-filter-branch.sh
index 9503875..4ee8237 100755
--- a/t/t7003-filter-branch.sh
+++ b/t/t7003-filter-branch.sh
@@ -306,4 +306,43 @@ test_expect_success '--remap-to-ancestor with filename filters' '
 	test $orig_invariant = $(git rev-parse invariant)
 '
 
+test_expect_success 'setup submodule' '
+	rm -rf * .*
+	git init &&
+	test_commit file &&
+	mkdir submod &&
+	submodurl="$PWD/submod"
+	( cd submod &&
+	  git init &&
+	  test_commit file-in-submod ) &&
+	git submodule add "$submodurl"
+	git commit -m "added submodule" &&
+	test_commit add-file &&
+	( cd submod && test_commit add-in-submodule ) &&
+	git add submod &&
+	git commit -m "changed submodule" &&
+	git branch original HEAD
+'
+
+orig_head=`git show-ref --hash --head HEAD`
+
+test_expect_success 'rewrite submodule with another content' '
+	git filter-branch --tree-filter "test -d submod && {
+					 rm -rf submod &&
+					 git rm -rf --quiet submod &&
+					 mkdir submod &&
+					 : > submod/file
+					 } || :" HEAD &&
+	test $orig_head != `git show-ref --hash --head HEAD`
+'
+
+test_expect_success 'replace submodule revision' '
+	git reset --hard original &&
+	git filter-branch -f --tree-filter \
+	    "if git ls-files --error-unmatch -- submod > /dev/null 2>&1
+	     then git update-index --cacheinfo 160000 0123456789012345678901234567890123456789 submod
+	     fi" HEAD &&
+	test $orig_head != `git show-ref --hash --head HEAD`
+'
+
 test_done
-- 
1.6.6

--
To unsubscribe from this list: send the line "unsubscribe git" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
Previous message: [thread] [date] [author]
Next message: [thread] [date] [author]

Messages in current thread:
filter-branch fix and tests , Michal Sojka, (Mon Jan 25, 6:06 am)
Re: [PATCH] filter-branch fix and tests, Michal Sojka, (Wed Jan 27, 8:49 am)
Re: [PATCH] filter-branch fix and tests, Johannes Sixt, (Wed Jan 27, 9:18 am)
Re: [PATCH] filter-branch fix and tests, Michal Sojka, (Wed Jan 27, 4:41 pm)
[PATCHv3] filter-branch: Add tests for submodules, Michal Sojka, (Wed Jan 27, 4:55 pm)
Re: [PATCHv3] filter-branch: Add tests for submodules, Junio C Hamano, (Wed Jan 27, 5:14 pm)
Re: [PATCHv3] filter-branch: Add tests for submodules, Michal Sojka, (Thu Jan 28, 2:02 am)
[PATCHv4 2/2] filter-branch: Add tests for submodules in t ..., Michal Sojka, (Thu Jan 28, 2:08 am)